Python try finally block returns [duplicate]

Posted on

Question :

Python try finally block returns [duplicate]

There is the interesting code below:

def func1():
    try:
        return 1
    finally:
        return 2

def func2():
    try:
        raise ValueError()
    except:
        return 1
    finally:
        return 3

func1()
func2()

Could please somebody explain, what results will return these two functions and explain why, i.e. describe the order of the execution

Asked By: skybobbi

||

Answer #1:

From the Python documentation

A finally clause is always executed before leaving the try statement, whether an exception has occurred or not. When an exception has occurred in the try clause and has not been handled by an except clause (or it has occurred in a except or else clause), it is re-raised after the finally clause has been executed. The finally clause is also executed “on the way out” when any other clause of the try statement is left via a break, continue or return statement. A more complicated example (having except and finally clauses in the same try statement works as of Python 2.5):

So once the try/except block is left using return, which would set the return value to given – finally blocks will always execute, and should be used to free resources etc. while using there another return – overwrites the original one.

In your particular case, func1() return 2 and func2() return 3, as these are values returned in the finally blocks.

Answered By: lejlot

Answer #2:

It will always go to the finally block, so it will ignore the return in the try and except. If you would have a return above the try and except, it would return that value.

def func1():
    try:
        return 1 # ignoring the return
    finally:
        return 2 # returns this return

def func2():
    try:
        raise ValueError()
    except:
        # is going to this exception block, but ignores the return because it needs to go to the finally
        return 1
    finally:
        return 3

def func3():
    return 0 # finds a return here, before the try except and finally block, so it will use this return 
    try:
        raise ValueError()
    except:
        return 1
    finally:
        return 3


func1() # returns 2
func2() # returns 3
func3() # returns 0
Answered By: 1408786user

Answer #3:

Putting print statements beforehand really, really helps:

def func1():
    try:
        print 'try statement in func1. after this return 1'
        return 1
    finally:
        print 'after the try statement in func1, return 2'
        return 2

def func2():
    try:
        print 'raise a value error'
        raise ValueError()
    except:
        print 'an error has been raised! return 1!'
        return 1
    finally:
        print 'okay after all that let's return 3'
        return 3

print func1()
print func2()

This returns:

try statement in func1. after this return 1
after the try statement in func1, return 2
2
raise a value error
an error has been raised! return 1!
okay after all that let's return 3
3

You’ll notice that python always returns the last thing to be returned, regardless that the code “reached” return 1 in both functions.

A finally block is always run, so the last thing to be returned in the function is whatever is returned in the finally block. In func1, that’s 2. In func2, that’s 3.

Answered By: TerryA

Answer #4:

func1() returns 2. func2() returns 3.

finally block is executed finally regardless or exception.

You can see order of execution using debugger. For example, see a screencast.

Answered By: falsetru

Leave a Reply

Your email address will not be published.